/**
 * Represents a croupier in Baccarat. The static methods encapsulate rules of
 * various kinds. The start() method controls the game flow.
 *
 * @author
 * @version
 */
public class BaccaratCroupier {

    private BaccaratTable table;

    private BaccaratShoe shoe;

    private Hand banker;

    private Hand player;

    /**
     * Stores the given table and shoe, and constructs the banker and player.
     *
     * @param table the BaccaratTable to use
     * @param shoe the BaccaratShoe to use
     */
    public BaccaratCroupier(BaccaratTable table, BaccaratShoe shoe) {
    }

    /**
     * Controls the play of the game.
     */
    public void start() {
    }

    /**
     * Determines if the given hand has a value of 8 or 9.
     *
     * @param hand the hand of cards
     * @return true if the hand is a natural; false otherwise
     */
    public static boolean isNatural(Hand hand) {
    }

    /**
     * Determines if the given hand must receive a card (using simple rules).
     *
     * @param hand the hand of cards
     * @return true if the hand must receive a card; false otherwise
     */
    public static boolean mustHit(Hand hand) {
    }

    /**
     * Determines if the given hand must receive a card (using complex rules
     * for the banker that involve the third card received by the player).
     *
     * @param playerCard the card received by the player
     * @param bankerHand the banker's hand
     * @return true if the hand must receive a card; false otherwise
     */
    public static boolean mustHit(Card playerCard, Hand bankerHand) {
    }

    /**
     * Determines who won the game, based on the values of hands.
     *
     * @param playerHand the player's Hand
     * @param bankerHand the banker's Hand
     * @return "Banker", "Player", or "Tie"
     */
    public static String outcomeOf(Hand playerHand, Hand bankerHand) {
    }

    /**
     * Calculates the value of the given card (based on the rules).
     *
     * @param card the Card
     * @return the value
     */
    public static int valueOf(Card card) {
    }

    /**
     * Calculates the value of the given hand (based on the rules).
     *
     * @param hand the Hand
     * @return the value
     */
    public static int valueOf(Hand hand) {
    }

}
