/**
 * An immutable encapsulation of a standard playing card.
 *
 * Note: This encapsulation is not appropriate for all card games because
 * each card can only have one possible value and in some card games
 * (e.g., blackjack) a Card can take on multiple possible values (e.g., an
 * Ace can have the value 1 or 11).
 *
 * @author
 * @version
 */
public class Card {

    public static final String[] RANKS = {
        null, "Ace", "2", "3", "4", "5", "6", "7",
        "8", "9", "10", "Jack", "Queen", "King"};

    public static final String[] SUITS = {
        "Clubs", "Diamonds", "Hearts", "Spades"};

    private final int rank;

    private final int suit;

    /**
     * Constructs a card with the given rank and suit (integers).
     *
     * @param rank the rank of the card
     * @param suit the suit of the card
     */
    public Card(int rank, int suit) {
    }

    /**
     * Constructs a card of the given rank and suit (strings).
     *
     * @param rank the string representation of the rank
     * @param suit the string representation of the suit
     */
    public Card(String rank, String suit) {
    }

    /**
     * Returns true if the given card has the same
     * rank AND same suit; otherwise returns false.
     *
     * @param other the other card
     * @return true if the same, false otherwise
     */
    public boolean equals(Card other) {
    }

    /**
     * Gets the card's rank.
     *
     * @return the rank
     */
    public int getRank() {
    }

    /**
     * Gets the card's suit.
     *
     * @return the suit
     */
    public int getSuit() {
    }

    /**
     * Determines the integer rank from the given string rank.
     *
     * @param str the string representation of the rank
     * @return the rank integer, or -1 if invalid
     */
    public static int parseRank(String str) {
    }

    /**
     * Determines the integer suit from the given string suit.
     *
     * @param str the string representation of the suit
     * @return the suit integer, or -1 if invalid
     */
    public static int parseSuit(String str) {
    }

    /**
     * Returns a string representation of the card.
     *
     * @return a string in "rank of suit" format
     */
    public String toString() {
    }

}
